'************************************************************************************************************
'Create registration of the [Raku Raku QR Master for Data Entry] add-in@2014.10@Hikawa Information Systems
'************************************************************************************************************
Option Explicit

Dim ExcelApp		'Excel Object
Dim AddinPath		'Addin Path
Dim OldPath		'Old Addinn Path
Dim objFSO		'FSO object
Dim wBook 		'Excel Book
Dim oldName
Dim xlAddIn		'Addin Object
Dim wVNo
Dim objShell		'Shell Object

'Create addin's install folder
Set objShell = WScript.CreateObject("WScript.Shell") 			'Shell object
AddinPath = objShell.SpecialFolders("AllUsersDesktop")
AddinPath = Left(AddinPath, InstrRev(AddinPath,"\"))
Set objFSO = CreateObject("Scripting.FileSystemObject") 		'FSO
On Error Resume Next
objFSO.CreateFolder(AddinPath & "Hikawa\")				'Create Install folder
AddinPath = AddinPath & "Hikawa\QRExport\"
objFSO.CreateFolder(AddinPath)
On Error Goto 0

'Copy Files
On Error Resume Next
objFSO.CopyFile "Files\HiQRBook.xla", AddinPath, True   		'Copy HiQRBook.xla
Set ExcelApp = CreateObject("Excel.Application")
IF IsNumeric(ExcelApp.Hinstance) = False then		'Office64bit̏ꍇ
	objFSO.CopyFile "Files\64\HIS_QRCode.dll",AddinPath, True
Else
	objFSO.CopyFile "Files\32\HIS_QRCode.dll",AddinPath, True
End If
objFSO.CopyFile "Files\HiEng.dat", AddinPath, True

If Err.Number <> 0 Then
	WScript.sleep(1000)
	objFSO.CopyFile "Files\HiQRBook.xla", AddinPath, True		'Copy HiQRBook.xla
	IF IsNumeric(ExcelApp.Hinstance) = False then		'Office64bit̏ꍇ
		objFSO.CopyFile "Files\64\HIS_QRCode.dll",AddinPath, True
	Else
		objFSO.CopyFile "Files\32\HIS_QRCode.dll",AddinPath, True
	End If
	objFSO.CopyFile "Files\HiEng.dat", AddinPath, True
End If
On Error Goto 0
Set objShell = Nothing

'Registration of time stamp for digital signature
'Set ExcelApp = CreateObject("Excel.Application")
Set wBook = ExcelApp.Workbooks.Open(AddinPath & "HiQRBook.xla")	'Open Addin
ExcelApp.Run("ExtModule.RegSignature")				'Call to registration of time stamp for digital signature
wBook.Close False
Set wBook = Nothing

'Delete Old ddin [HiQRBook]						
Set wBook = ExcelApp.Workbooks.Add				'Create work book
On Error Resume Next
Set xlAddIn = ExcelApp.AddIns("HiQRBook")
If Err.Number = 0 Then
	OldPath = xlAddIn.Path
	wVNo = Split(ExcelApp.Version, ".")(0)
	If StrComp(OldPath & "\", AddinPath, 1) <> 0 Then
		oldName = xlAddIn.FullName
		xlAddIn.Installed = False			'UnInstall addin
		wBook.Close False
		ExcelApp.Quit
		objFSO.DeleteFile OldPath & "HiQRBook.xla", True
		DeleteEntry(oldName)
		Set ExcelApp = CreateObject("Excel.Application")	'Excel object
		If Err.Number <> 0 Then
			Err.Clear
			'When Excel2013
			Set ExcelApp = CreateObject("Excel.Application.15")
		End if
		Set wBook = ExcelApp.Workbooks.Add
	End If
End If

'Registration of addin
Set objFSO = Nothing
ExcelApp.AddIns.Add AddinPath & "HiQRBook.xla"	
ExcelApp.AddIns("HiQRBook").Installed = True		'Install addin
wBook.Close False
Set xlAddIn = Nothing
Set wBook = Nothing
ExcelApp.Quit						'Quit Excel

'Retry registrattion of addin
Set ExcelApp = CreateObject("Excel.Application")	'Excel Object
If Err.Number <> 0 Then
	Err.Clear
	'When Excel2013
	Set ExcelApp = CreateObject("Excel.Application.15")
End if

Set wBook = ExcelApp.Workbooks.Add
ExcelApp.AddIns.Add AddinPath & "HiQRBook.xla"	
ExcelApp.AddIns("HiQRBook").Installed = True		'Install addin
wBook.Close False
Set wBook = Nothing
ExcelApp.Quit
Set ExcelApp = Nothing					'Free object

MsgBox "Registration of the [Raku Raku QR Master for Data Entry] add-in is complete.",64,"Raku Raku QR Master for Data Entry"

'Delete registration of the addin
Sub DeleteEntry(ByVal pAddin)
	Dim wText, wTemp

	wText = "REGEDIT4" & vbCrLf & vbCrLf _
       		& "[HKEY_CURRENT_USER\Software\Microsoft\Office\" _
       		& FormatNumber(wVNo, 1) & "\Excel\Add-in Manager]" _
       		& vbCrLf & """" & Replace(pAddin, "\", "\\") & """=-" & vbCrLf
	With objFSO
   		wTemp = .BuildPath(.GetSpecialFolder(2).Path, .GetTempName)
   		With .CreateTextFile(wTemp)
      			.Write wText: .Close
   		End With
   		With CreateObject("wscript.shell")
      			.Run "regedit /s " & wTemp, 0, True
   		End With
		.DeleteFile wTemp
	End With
End Sub
