'************************************************************************************************************
'Delete registration of the [Raku Raku QR Master for Data Entry] add-in@2014.10@Hikawa Information Systems
'************************************************************************************************************
Option Explicit
Dim ExcelApp	'Excel Object
Dim Path	'Addin Path
Dim AddinPath	'Office Library Path
Dim objShell	'Shell Object
Dim objFSO	'FSO object
Dim wBook 	'Excel Book
Dim xlAddIn	'Addin Object
Dim wVNo	'Office Version Number

'Create Excel object
On Error Resume Next
Set ExcelApp = CreateObject("Excel.Application")		'Excel object
If Err.Number <> 0 Then
	Err.Clear
	'When Excel2013
	Set ExcelApp = CreateObject("Excel.Application.15")
End if
On Error goto 0

'Adinn Install forder'path
Set objShell = WScript.CreateObject("WScript.Shell") 	'Shell object
AddinPath = objShell.SpecialFolders("AllUsersDesktop")
AddinPath = Left(AddinPath, InstrRev(AddinPath,"\"))
AddinPath = AddinPath & "Hikawa\QRExport\"

'Delete Addinn's commands
Set wBook = ExcelApp.Workbooks.Open(AddinPath & "HiQRBook.xla")	
ExcelApp.Run("mPwQRCode.HiDelCBar")
wBook.Close False
ExcelApp.Quit
Set wBook = Nothing
Set ExcelApp = Nothing
Set objShell = Nothing

'Create Excel Object
On Error Resume Next
Set ExcelApp = CreateObject("Excel.Application")
If Err.Number <> 0 Then
	Err.Clear
	'When Excel2013
	Set ExcelApp = CreateObject("Excel.Application.15")
End if
On Error goto 0

'Delete Addin [HiQRBook]					
Set wBook = ExcelApp.Workbooks.Add	'Create Work book object for delete addin
On Error Resume Next	
Set xlAddIn = ExcelApp.AddIns("HiQRBook")
If Err.Number = 0 Then
	Path = xlAddIn.Path
	'Wscript.Echo "old AddinPath=" & Path & "\"
	'Wscript.Echo "new AddinPath=" & AddinPath
	wVNo = Split(ExcelApp.Version, ".")(0)
	If StrComp(Path & "\",AddinPath, 1) = 0 Then
		'FSO̐
		Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")	
		xlAddIn.Installed = False	'Uninstall addinn
		wBook.Close False
		ExcelApp.Quit
		objFSO.DeleteFile Path & "\HiQRBook.xla", True	'Delete Install files
		objFSO.DeleteFile Path & "\HIS_QRCode.dll", True
		objFSO.DeleteFile Path & "\HiEng.dat", True
		objFSO.DeleteFolder(Path)					'Delete folder's path
		'Wscript.Echo "Path=" & Left(Path, InstrRev(Path,"\") -1)
		objFSO.DeleteFolder(Left(Path, InstrRev(Path,"\") -1))	
		DeleteEntry(xlAddIn.FullName)
		Set objFSO = Nothing
		Set ExcelApp = CreateObject("Excel.Application")
		If Err.Number <> 0 Then
			Err.Clear
			'When Excel2013
			Set ExcelApp = CreateObject("Excel.Application.15")
		End if
		Set wBook = ExcelApp.Workbooks.Add
	End If
	xlAddIn.Installed = False				'Uninstall addin
End If
wBook.Close False
Set xlAddIn = Nothing
Set wBook = Nothing
ExcelApp.Quit							'Quit Excel
Set ExcelApp = Nothing						'Free Object

MsgBox "Delete registration of the [Raku Raku QR Master for Data Entry] add-in is complete.",64,"Raku Raku QR Master for Data Entry"

'Delete registration of the addin
Sub DeleteEntry(ByVal pAddin)
	Dim wText, wTemp

	wText = "REGEDIT4" & vbCrLf & vbCrLf _
       		& "[HKEY_CURRENT_USER\Software\Microsoft\Office\" _
       		& FormatNumber(wVNo, 1) & "\Excel\Add-in Manager]" _
       		& vbCrLf & """" & Replace(pAddin, "\", "\\") & """=-" & vbCrLf
	With objFSO
   		wTemp = .BuildPath(.GetSpecialFolder(2).Path, .GetTempName)
   		With .CreateTextFile(wTemp)
      			.Write wText: .Close
   		End With
   		With CreateObject("wscript.shell")
      			.Run "regedit /s " & wTemp, 0, True
   		End With
		.DeleteFile wTemp
	End With
End Sub

